----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

source(Utils.getFilename("instantWash.lua", g_currentModDirectory));

function installSpec()
	if g_specializationManager:getSpecializationByName("instantWash") == nil then
		if instantWash == nil then 
			print("ERROR: unable to find source file 'instantWash.lua'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.types) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						end;
					end;
					if isWashable then
						 if typeDef.specializationsByName["instantWash"] == nil then
							table.insert(typeDef.specializations, instantWash);
							table.insert(typeDef.specializationNames, "instantWash");
							typeDef.specializationsByName["instantWash"] = instantWash;
						end;
					end;
				end;
			end;
		end;	
	end;
end;

TypeManager.validateTypes = Utils.appendedFunction(TypeManager.validateTypes, installSpec);